import { ElementType, useCallback } from "react";
import { useAppDispatch } from "../../hooks";

export type SubmitHandler = (setUpsertModel: any, e: any) => void;

export const WithForm = (Component: ElementType) => {
  return function WithFormComponent({ ...props }: {
    [key: string]: any;
  }) {
    const dispatch = useAppDispatch();

    const handleFormDataChange = useCallback((
      setUpsertModel: any,
      { currentTarget }: any
    ) => {
      const data: any = {};

      for (const input of currentTarget.elements) {
        if (input.name !== null && input.name !== '') {
          data[input.name] = input.value;
        }
      };

      dispatch(setUpsertModel({
        data: {
          attributes: data,
        },
      }));
    }, [dispatch]);

    props = {
      handleSubmit: (setUpsertModel: any, e: any) => {
        e.preventDefault();
        handleFormDataChange(setUpsertModel, e);
      },
      ...props,
    };

    return <Component {...props} />;
  };
};
